commit 4c72a54cb0b2745713595adaecfc1bad548c03e0
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Jul 15 13:21:06 2019 +0200

    Massive overhaul:
    - updated to a new version of AMiRo-LLD
    - tests (formerly unit tests) are now split onto multiple parts:
      - there are "global" tests for each driver etc.
      - there is an individual part for each module, e.g. if there are multiple instances of the same periphery
    - a lot of minor enhancements

diff --git a/amiroos.h b/amiroos.h
index fa9b740..251d8d2 100644
--- a/amiroos.h
+++ b/amiroos.h
@@ -90,7 +90,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #include "core/inc/aos_shell.h"
 #include "core/inc/aos_system.h"
 #include "core/inc/aos_thread.h"
-#include "core/inc/aos_unittest.h"
+#include "core/inc/aos_test.h"
 
 /* module specifications */
 #include <module.h>
diff --git a/amiroos.mk b/amiroos.mk
new file mode 100644
index 0000000..da99b7b
--- /dev/null
+++ b/amiroos.mk
@@ -0,0 +1,97 @@
+################################################################################
+# AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
+# (AMiRo) platform.                                                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
+#                                                                              #
+# This program is free software: you can redistribute it and/or modify         #
+# it under the terms of the GNU General Public License as published by         #
+# the Free Software Foundation, either version 3 of the License, or            #
+# (at your option) any later version.                                          #
+#                                                                              #
+# This program is distributed in the hope that it will be useful,              #
+# but WITHOUT ANY WARRANTY; without even the implied warranty of               #
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                #
+# GNU General Public License for more details.                                 #
+#                                                                              #
+# You should have received a copy of the GNU General Public License            #
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.        #
+#                                                                              #
+# This research/work was supported by the Cluster of Excellence Cognitive      #
+# Interaction Technology 'CITEC' (EXC 277) at Bielefeld University, which is   #
+# funded by the German Research Foundation (DFG).                              #
+################################################################################
+
+
+
+# absolute path to this directory
+AMIROOS_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
+
+# set AMiRo-OS path variable
+AMIROOS := $(AMIROOS_DIR:/=)
+
+# load bootloader files
+include $(AMIROOS)/bootloader/bootloader.mk
+
+# load kernel files
+include $(AMIROOS)/kernel/kernel.mk
+
+# load peryphery LLD files
+include $(AMIROOS)/periphery-lld/periphery-lld.mk
+
+# load AMiRo-OS files
+include $(AMIROOS)/modules/modules.mk
+include $(AMIROOS)/core/core.mk
+include $(AMIROOS)/test/test.mk
+
+# inclusion directories
+AMIROOS_INC = $(CONFDIR) \
+              $(AMIROOS) \
+              $(AMIROOS_BOOTLOADER_INC) \
+              $(AMIROOS_KERNEL_INC) \
+              $(AMIROOS_PERIPHERYLLD_INC) \
+              $(AMIROOS_MODULES_INC) \
+              $(AMIROOS_CORE_INC) \
+              $(AMIROOS_TEST_INC) \
+              $(MODULE_INC) \
+              $(APPS_INC)
+
+# C sources that can be compiled in ARM or THUMB mode depending on the global setting
+AMIROOS_CSRC = $(AMIROOS_BOOTLOADER_CSRC) \
+               $(AMIROOS_KERNEL_CSRC) \
+               $(AMIROOS_PERIPHERYLLD_CSRC) \
+               $(AMIROOS_MODULES_CSRC) \
+               $(AMIROOS_CORE_CSRC) \
+               $(AMIROOS_TEST_CSRC) \
+               $(MODULE_CSRC) \
+               $(APPS_CSRC)
+
+# C++ sources that can be compiled in ARM or THUMB mode depending on the global setting
+AMIROOS_CPPSRC = $(AMIROOS_BOOTLOADER_CPPSRC) \
+                 $(AMIROOS_KERNEL_CPPSRC) \
+                 $(AMIROOS_PERIPHERYLLD_CPPSRC) \
+                 $(AMIROOS_MODULES_CPPSRC) \
+                 $(AMIROOS_CORE_CPPSRC) \
+                 $(AMIROOS_TEST_CPPSRC) \
+                 $(MODULE_CPPSRC) \
+                 $(APPS_CPPSRC)
+
+# ASM source files
+AMIROOS_ASMSRC = $(AMIROOS_BOOTLOADER_ASMSRC) \
+                 $(AMIROOS_KERNEL_ASMSRC) \
+                 $(AMIROOS_PERIPHERYLLD_ASMSRC) \
+                 $(AMIROOS_MODULES_ASMSRC) \
+                 $(AMIROOS_CORE_ASMSRC) \
+                 $(AMIROOS_TEST_ASMSRC) \
+                 $(MODULE_ASMSRC) \
+                 $(APPS_ASMSRC)
+
+# ASM with preprocessor source files here
+AMIROOS_ASMXSRC = $(AMIROOS_BOOTLOADER_ASMXSRC) \
+                  $(AMIROOS_KERNEL_ASMXSRC) \
+                  $(AMIROOS_PERIPHERYLLD_ASMXSRC) \
+                  $(AMIROOS_MODULES_ASMXSRC) \
+                  $(AMIROOS_CORE_ASMXSRC) \
+                  $(AMIROOS_TEST_ASMXSRC) \
+                  $(MODULE_ASMXSRC) \
+                  $(APPS_ASMXSRC)
+
diff --git a/bootloader/AMiRo-BLT b/bootloader/AMiRo-BLT
index e687187..591c0fd 160000
--- a/bootloader/AMiRo-BLT
+++ b/bootloader/AMiRo-BLT
@@ -1 +1 @@
-Subproject commit e687187fa4dbbfab6c4abfb180dfaf8f3829dfa6
+Subproject commit 591c0fd3a0677d69b3e1c89fa9e202797cb04a36
diff --git a/bootloader/bootloader.mk b/bootloader/bootloader.mk
index fc7b408..f5c6f7b 100644
--- a/bootloader/bootloader.mk
+++ b/bootloader/bootloader.mk
@@ -24,12 +24,16 @@
 
 
 # the path to this makefile
-BOOTLOADER_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
+AMIROOS_BOOTLOADER_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
 
-# the interface for the bootloader
-BOOTLOADERINC = $(BOOTLOADER_DIR)AMiRo-BLT/Target/Source/AMiRo
+# set AMiRo-BLT path variable
+AMIROBLT := $(AMIROOS_BOOTLOADER_DIR)AMiRo-BLT
 
-include $(BOOTLOADER_DIR)AMiRo-BLT/Target/Modules/moduleids.mk
+# include paths
+AMIROOS_BOOTLOADER_INC = $(AMIROBLT)/Target/Source/AMiRo
+
+# load module ID constants
+include $(AMIROBLT)/Target/Modules/moduleids.mk
 
 # some flashing parameters
 ifeq ($(OS),Windows_NT)
@@ -52,20 +56,20 @@ endif
 FLASH_BAUDRATE ?= 115200
 
 # set the flashing tool, the command to call it, arguments, and file extensions
-ifneq ($(wildcard $(BOOTLOADER_DIR)AMiRo-BLT/Host/Source/SerialBoot/build/SerialBoot),)
+ifneq ($(wildcard $(AMIROBLT)/Host/Source/SerialBoot/build/SerialBoot),)
 	# if AMiRo-BLT project is available, use SerialBoot
-	FLASHTOOL = SerialBoot
-	FLASHTOOL_CMD = $(BOOTLOADER_DIR)AMiRo-BLT/Host/Source/SerialBoot/build/SerialBoot
-	FLASHTOOL_EXT = srec
+	FLASHTOOL := SerialBoot
+	FLASHTOOL_CMD := $(AMIROBLT)/Host/Source/SerialBoot/build/SerialBoot
+	FLASHTOOL_EXT := srec
 	FLASHTOOL_ARGS = -d$(FLASH_PORT) -b$(FLASH_BAUDRATE) $(foreach module,$(FLASH_MODULES),-T$($(module)_ID_HEX) $(BUILDDIR)/$(module).$(FLASHTOOL_EXT))
 else
 	# the default tool to use is stm32flash
 	ifneq ($(words $(FLASH_MODULES)),1)
 		FLASH_MODULES := $(firstword $(FLASH_MODULES))
 	endif
-	FLASHTOOL = stm32flash
-	FLASHTOOL_CMD = stm32flash
-	FLASHTOOL_EXT = hex
+	FLASHTOOL := stm32flash
+	FLASHTOOL_CMD := stm32flash
+	FLASHTOOL_EXT := hex
 	FLASHTOOL_ARGS = $(FLASH_PORT) -i "rts,-dtr,-rts":"rts,dtr,-rts" -R -b $(FLASH_BAUDRATE) -w $(BUILDDIR)/$(FLASH_MODULES).$(FLASHTOOL_EXT)
 endif
 
diff --git a/core/core.mk b/core/core.mk
index c647a16..a1c9dbc 100644
--- a/core/core.mk
+++ b/core/core.mk
@@ -27,11 +27,11 @@
 AMIROOS_CORE_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
 
 # include paths
-AMIROOSCOREINC = $(AMIROOS_CORE_DIR)inc
+AMIROOS_CORE_INC = $(AMIROOS_CORE_DIR)inc
 
 # C source files
-AMIROOSCORECSRC = $(wildcard $(AMIROOS_CORE_DIR)src/*.c)
+AMIROOS_CORE_CSRC = $(wildcard $(AMIROOS_CORE_DIR)src/*.[Cc])
 
 # C++ source files
-AMIROOSCORECPPSRC = $(wildcard $(AMIROOS_CORE_DIR)src/*.c?*)
+AMIROOS_CORE_CPPSRC = $(wildcard $(AMIROOS_CORE_DIR)src/*.[Cc]?*)
 
diff --git a/core/inc/aos_shell.h b/core/inc/aos_shell.h
index 4cc23fd..b54f46b 100644
--- a/core/inc/aos_shell.h
+++ b/core/inc/aos_shell.h
@@ -195,6 +195,10 @@ typedef struct aos_shellstream {
 
 /**
  * @brief   Shell command calback type.
+ *
+ * @param[in] stream  Stream to print to.
+ * @param[in] argc    Number of arguments.
+ * @param[in] argv    List of arguments.
  */
 typedef int (*aos_shellcmdcb_t)(BaseSequentialStream* stream, int argc, char* argv[]);
 
@@ -373,6 +377,19 @@ typedef struct aos_shell {
 /* MACROS                                                                     */
 /******************************************************************************/
 
+/**
+ * @brief   Initializes a shell command object.
+ *
+ * @param[in] var       Name of the object variable to be initialized.
+ * @param[in] name      Shell command name.
+ * @param[in] callback  Pointer to the callback function.
+ */
+#define AOS_SHELL_COMMAND(var, name, callback) aos_shellcommand_t var = {     \
+  /* name     */ name,                                                        \
+  /* callback */ callback,                                                    \
+  /* next     */ NULL,                                                        \
+}
+
 /******************************************************************************/
 /* EXTERN DECLARATIONS                                                        */
 /******************************************************************************/
diff --git a/core/inc/aos_test.h b/core/inc/aos_test.h
new file mode 100644
index 0000000..bf72354
--- /dev/null
+++ b/core/inc/aos_test.h
@@ -0,0 +1,175 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+/**
+ * @file    aos_test.h
+ * @brief   Test structures and interfaces.
+ *
+ * @addtogroup aos_unittests
+ * @{
+ */
+
+#ifndef AMIROOS_TEST_H
+#define AMIROOS_TEST_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/*
+ * forward declarations
+ */
+typedef struct aos_testresult aos_testresult_t;
+typedef struct aos_test aos_test_t;
+
+/**
+ * @brief   Test interface function definition.
+ *
+ * @param[in] stream  The stream to use for printing messages.
+ * @param[in] ut      The object to run the test on.
+ *
+ * @return    Result containing the number of passed and failed tests.
+ */
+typedef aos_testresult_t (*aos_testfunction_t)(BaseSequentialStream* stream, const aos_test_t* test);
+
+/**
+ * @brief   Wrapper interface definition to allow programmatical shell-like call
+ *          of the test.
+ * @details While the first three arguments (stream, argc and argv) as well as
+ *          the return value are identical to a shell command, the additional
+ *          optional argument (result) is set by the function.
+ *
+ * @param[in]   stream  Stream to print to.
+ * @param[in]   argc    Number of arguments given.
+ * @param[in]   argv    List of arguments.
+ * @param[out]  result  Result of the test (optional).
+ *
+ * @return    Execution status of the function, which can be passed on to a
+ *            shell callback.
+ */
+typedef int (*aos_testshellcallback_t)(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+
+/**
+ * @brief   Test result struct.
+ */
+struct aos_testresult {
+  /**
+   * @brief   Number of passed tests.
+   */
+  uint32_t passed;
+
+  /**
+   * @brief   Number of failed tests.
+   */
+  uint32_t failed;
+};
+
+/**
+ * @brief   Test definition struct.
+ */
+struct aos_test {
+  /**
+   * @brief   Name of the test.
+   */
+  const char* name;
+
+  /**
+   * @brief   Further information about the test.
+   */
+  const char* info;
+
+  /**
+   * @brief   Callback function to serve as wrapper between shell and test.
+   *
+   * @details The purpose of this wrapper is to be able to execute tests
+   *          programatically exactly like a shell command from the CLI. It
+   *          should handle any required setup depending on given arguments and
+   *          eventually execute the test.
+   */
+  aos_testshellcallback_t shellcb;
+
+  /**
+   * @brief   Callback function to run that executes the test.
+   */
+  aos_testfunction_t testfunc;
+
+  /**
+   * @brief   Further test specific data.
+   */
+  void* data;
+};
+
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+#define AOS_TEST(var, name, info, shellcb, testfunc, data) aos_test_t var = { \
+  /* name     */ name,                                                        \
+  /* info     */ info,                                                        \
+  /* shellcb  */ shellcb,                                                     \
+  /* testfunc */ testfunc,                                                    \
+  /* data     */ data,                                                        \
+}
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestResultAdd(aos_testresult_t a, aos_testresult_t b);
+  uint32_t aosTestResultTotal(const aos_testresult_t* result);
+  float aosTestResultRatio(const aos_testresult_t* result);
+  void aosTestResultPrintSummary(BaseSequentialStream* stream, const aos_testresult_t* result, const char* heading);
+  aos_testresult_t aosTestRun(BaseSequentialStream* stream, const aos_test_t* test, const char* note);
+  void aosTestPassed(BaseSequentialStream* stream, aos_testresult_t* result);
+  void aosTestPassedMsg(BaseSequentialStream* stream, aos_testresult_t* result, const char* fmt, ...);
+  void aosTestFailed(BaseSequentialStream* stream, aos_testresult_t* result);
+  void aosTestFailedMsg(BaseSequentialStream* stream, aos_testresult_t* result, const char* fmt, ...);
+  void aosTestInfoMsg(BaseSequentialStream* stream, const char* fmt, ...);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_H */
+
+/** @} */
diff --git a/core/src/aos_main.cpp b/core/src/aos_main.cpp
index 9aff409..37a8c1c 100644
--- a/core/src/aos_main.cpp
+++ b/core/src/aos_main.cpp
@@ -996,11 +996,11 @@ int main(void)
 #endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_4) */
 
-  /* periphery communication initialization */
+  /* periphery communication interfaces initialization */
   // module specific initialization (if any)
-#if defined(MODULE_INIT_PERIPHERY_COMM)
-  MODULE_INIT_PERIPHERY_COMM();
-#endif /* defined(MODULE_INIT_PERIPHERY_COMM) */
+#if defined(MODULE_INIT_PERIPHERY_IF)
+  MODULE_INIT_PERIPHERY_IF();
+#endif /* defined(MODULE_INIT_PERIPHERY_IF) */
 #if ((SSSP_STAGE3_ENABLE == true) && (HAL_USE_CAN == TRUE))
   // CAN
   if (MODULE_HAL_CAN.state == CAN_STOP) {
@@ -1339,10 +1339,10 @@ int main(void)
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_3) */
 
-  /* stop all periphery communication */
-#if defined(MODULE_SHUTDOWN_PERIPHERY_COMM)
-  MODULE_SHUTDOWN_PERIPHERY_COMM();
-#endif /* defined(MODULE_SHUTDOWN_PERIPHERY_COMM) */
+  /* stop all periphery communication interfaces */
+#if defined(MODULE_SHUTDOWN_PERIPHERY_IF)
+  MODULE_SHUTDOWN_PERIPHERY_IF();
+#endif /* defined(MODULE_SHUTDOWN_PERIPHERY_IF) */
 #if (HAL_USE_CAN == TRUE)
   if (MODULE_HAL_CAN.state != CAN_STOP) {
     canStop(&MODULE_HAL_CAN);
diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index 3450b97..6917d4b 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -147,43 +147,27 @@ static char* _shell_arglist[AMIROOS_CFG_SHELL_MAXARGS];
 /**
  * @brief   Shell command to retrieve system information.
  */
-static aos_shellcommand_t _shellcmd_info = {
-  /* name     */ "module:info",
-  /* callback */ _shellcmd_infocb,
-  /* next     */ NULL,
-};
+static AOS_SHELL_COMMAND(_shellcmd_info, "module:info", _shellcmd_infocb);
 
 /**
  * @brief   Shell command to set or retrieve system configuration.
  */
-static aos_shellcommand_t _shellcmd_config = {
-  /* name     */ "module:config",
-  /* callback */ _shellcmd_configcb,
-  /* next     */ NULL,
-};
+static AOS_SHELL_COMMAND(_shellcmd_config, "module:config", _shellcmd_configcb);
 
 /**
  * @brief   Shell command to shutdown the system.
  */
-static aos_shellcommand_t _shellcmd_shutdown = {
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
-  /* name     */ "system:shutdown",
+static AOS_SHELL_COMMAND(_shellcmd_shutdown, "system:shutdown", _shellcmd_shutdowncb);
 #else /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-  /* name     */ "module:shutdown",
+static AOS_SHELL_COMMAND(_shellcmd_shutdown, "module:shutdown", _shellcmd_shutdowncb);
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-  /* callback */ _shellcmd_shutdowncb,
-  /* next     */ NULL,
-};
 
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Shell kommand to run a test of the ChibiOS/RT kernel.
  */
-static aos_shellcommand_t _shellcmd_kerneltest = {
-  /* name     */ "kernel:test",
-  /* callback */ _shellcmd_kerneltestcb,
-  /* next     */ NULL,
-};
+static AOS_SHELL_COMMAND(_shellcmd_kerneltest, "kernel:test", _shellcmd_kerneltestcb);
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 #endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
 
@@ -561,7 +545,7 @@ static int _shellcmd_infocb(BaseSequentialStream* stream, int argc, char* argv[]
 #if (AMIROOS_CFG_DBG == true)
   chprintf(stream, "\tthread stack size:      %u bytes\n", aosThdGetStacksize(aos.shell.thread));
 #if (CH_DBG_FILL_THREADS == TRUE)
-  chprintf(stream, "\tstack peak utilization: %u bytes (%.2f%%)\n", aosThdGetStackPeakUtilization(aos.shell.thread), (float)aosThdGetStackPeakUtilization(aos.shell.thread) / (float)aosThdGetStacksize(aos.shell.thread) * 100.0f);
+  chprintf(stream, "\tstack peak utilization: %u bytes (%.2f%%)\n", aosThdGetStackPeakUtilization(aos.shell.thread), (float)(aosThdGetStackPeakUtilization(aos.shell.thread)) / (float)(aosThdGetStacksize(aos.shell.thread)) * 100.0f);
 #endif /* (CH_DBG_FILL_THREADS == TRUE) */
 #endif /* (AMIROOS_CFG_DBG == true) */
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
diff --git a/core/src/aos_test.c b/core/src/aos_test.c
new file mode 100644
index 0000000..3f3cfc0
--- /dev/null
+++ b/core/src/aos_test.c
@@ -0,0 +1,286 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+/**
+ * @file    aos_test.c
+ * @brief   Test code.
+ * @details Functions to initialize and run tests,
+ *          as well as utility functions to be used in tests.
+ *
+ * @addtogroup aos_tests
+ * @{
+ */
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <string.h>
+#include <stdarg.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   Adds two result objects.
+ *
+ * @param[in] a   The first summand.
+ * @param[in] b   The second summand.
+ *
+ * @return    Resulting sum of both summands added.
+ */
+inline aos_testresult_t aosTestResultAdd(aos_testresult_t a, aos_testresult_t b)
+{
+  a.passed += b.passed;
+  a.failed += b.failed;
+
+  return a;
+}
+
+/**
+ * @brief   Retrieve the total number of tests (passed and failed).
+ *
+ * @param[in] result    The result object to evaluate.
+ *
+ * @return  Number of total tests executed.
+ */
+inline uint32_t aosTestResultTotal(const aos_testresult_t* result)
+{
+  aosDbgCheck(result != NULL);
+
+  return result->passed + result->failed;
+}
+
+/**
+ * @brief   Retrieve the ratio of passed tests.
+ *
+ * @param[in] result    The result object to evaluate.
+ *
+ * @return  Ratio of passed tests to total tests as float in range [0, 1].
+ */
+inline float aosTestResultRatio(const aos_testresult_t *result)
+{
+  aosDbgCheck(result != NULL);
+
+  if (aosTestResultTotal(result) > 0) {
+    return (float)result->passed / (float)(aosTestResultTotal(result));
+  } else {
+    return 1.0f;
+  }
+}
+
+/**
+ * @brief   Print the summary of a test.
+ * @details The summary consists of:
+ *          - total numer of tests executed
+ *          - absolute number of passed tests
+ *          - absolute number of failed tests
+ *          - relative ratio of passed tests
+ *
+ * @param[in] stream    Stream to print the result to.
+ * @param[in] result    Result to evaluate and print.
+ * @param[in] heading   Optional heading (defaults to "summary").
+ */
+void aosTestResultPrintSummary(BaseSequentialStream *stream, const aos_testresult_t* result, const char* heading)
+{
+  aosDbgCheck(stream != NULL);
+  aosDbgCheck(result != NULL);
+
+  chprintf(stream, "%s:\n", (heading != NULL) ? heading : "summary");
+  chprintf(stream, "\ttotal:  %3u\n", aosTestResultTotal(result));
+  chprintf(stream, "\tpassed: %3u\n", result->passed);
+  chprintf(stream, "\tfailed: %3u\n", result->failed);
+  chprintf(stream, "\tratio:  %3u%%\n", (uint8_t)(aosTestResultRatio(result) * 100.0f)); // implicitly rounded off by cast to integer
+
+  return;
+}
+
+/**
+ * @brief   Run a test.
+ *
+ * @param[in] stream  A stream for printing messages.
+ * @param[in] test    Test to execute.
+ * @param[in] note    Optional note string.
+ *
+ * @return    Result of the test.
+ */
+aos_testresult_t aosTestRun(BaseSequentialStream *stream, const aos_test_t *test, const char* note)
+{
+  aosDbgCheck(stream != NULL);
+  aosDbgCheck(test != NULL);
+
+  // print name heading
+  {
+    chprintf(stream, "\n");
+    const int nchars = chprintf(stream, "%s test\n", test->name);
+    for (int c = 0; c < nchars-1; ++c) {
+      chprintf(stream, "=");
+    }
+    chprintf(stream, "\n");
+  }
+
+  // print info (if any)
+  if (test->info != NULL) {
+    chprintf(stream, "info: %s\n", test->info);
+  }
+  // print note (if any)
+  if (note != NULL) {
+    chprintf(stream, "note: %s\n", note);
+  }
+  chprintf(stream, "\n");
+
+  // run test
+  aos_testresult_t result = test->testfunc(stream, test);
+
+  // print summary
+  aosTestResultPrintSummary(stream, &result, NULL);
+
+  return result;
+}
+
+/**
+ * @brief   Helper function for passed tests.
+ * @details Prints a message that the test was passed and modifies the result accordigly.
+ *
+ * @param[in] stream      Stream to print the message to.
+ * @param[in,out] result  Result object to modify.
+ */
+void aosTestPassed(BaseSequentialStream *stream, aos_testresult_t* result)
+{
+  aosDbgCheck(stream != NULL);
+  aosDbgCheck(result != NULL);
+
+  ++result->passed;
+  chprintf(stream, "\tPASSED\n");
+  chprintf(stream, "\n");
+
+  return;
+}
+
+/**
+ * @brief   Helper function for passed tests.
+ * @details Prints a message that the test was passed, an additional custom message, and modifies the result accordigly.
+ *
+ * @param[in] stream      Stream to print the message to.
+ * @param[in,out] result  Result object to modify.
+ * @param[in] fmt         Formatted message string.
+ */
+void aosTestPassedMsg(BaseSequentialStream *stream, aos_testresult_t* result, const char *fmt, ...)
+{
+  aosDbgCheck(stream != NULL);
+  aosDbgCheck(result != NULL);
+
+  va_list ap;
+
+  ++result->passed;
+  chprintf(stream, "\tPASSED\t");
+  va_start(ap, fmt);
+  chvprintf(stream, fmt, ap);
+  va_end(ap);
+  chprintf(stream, "\n");
+
+  return;
+}
+
+/**
+ * @brief   Helper function for failed tests.
+ * @details Prints a message that the test was failed and modifies the result accordigly.
+ *
+ * @param[in] stream      Stream to print the message to.
+ * @param[in,out] result  Result object to modify.
+ */
+void aosTestFailed(BaseSequentialStream *stream, aos_testresult_t* result)
+{
+  aosDbgCheck(stream != NULL);
+  aosDbgCheck(result != NULL);
+
+  ++result->failed;
+  chprintf(stream, "\tFAILED\n");
+  chprintf(stream, "\n");
+
+  return;
+}
+
+/**
+ * @brief   Helper function for failed tests.
+ * @details Prints a message that the test was failed, an additional custom message, and modifies the result accordigly.
+ *
+ * @param[in] stream      Stream to print the message to.
+ * @param[in,out] result  Result object to modify.
+ * @param[in] fmt         Formatted message string.
+ */
+void aosTestFailedMsg(BaseSequentialStream *stream, aos_testresult_t* result, const char *fmt, ...)
+{
+  aosDbgCheck(stream != NULL);
+  aosDbgCheck(result != NULL);
+
+  va_list ap;
+
+  ++result->failed;
+  chprintf(stream, "\tFAILED\t");
+  va_start(ap, fmt);
+  chvprintf(stream, fmt, ap);
+  va_end(ap);
+  chprintf(stream, "\n");
+
+  return;
+}
+
+/**
+ * @brief   Helper function for information messages.
+ *
+ * @param[in] stream  Strean to rpint the message to.
+ * @param[in] fmt     Formatted message string.
+ */
+void aosTestInfoMsg(BaseSequentialStream* stream, const char* fmt, ...)
+{
+  aosDbgCheck(stream != NULL);
+
+  va_list ap;
+  va_start(ap, fmt);
+  chvprintf(stream, fmt, ap);
+  va_end(ap);
+  chprintf(stream, "\n");
+
+  return;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+/** @} */
